'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

//      

var useAsyncFunction = (function (config, listener) {
  var start = config.start,
      resolve = config.resolve,
      reject = config.reject,
      setPayload = config.setPayload,
      getPayload = config.getPayload,
      getError = config.getError;

  var createAsyncFunction = function createAsyncFunction() {
    return listener.createAsyncFunction({
      start: start,
      resolve: resolve,
      reject: reject,
      setPayload: setPayload,
      getPayload: getPayload,
      getError: getError
    });
  };

  // $FlowFixMe: Remember to update Flow

  var _React$useState = React.useState(createAsyncFunction()),
      _React$useState2 = slicedToArray(_React$useState, 2),
      asyncFunction = _React$useState2[0],
      setAsyncFunction = _React$useState2[1];

  // $FlowFixMe: Remember to update Flow


  React.useEffect(function () {
    asyncFunction.unsubscribe();
    setAsyncFunction(createAsyncFunction());

    return function () {
      asyncFunction.unsubscribe();
    };
  }, [start, resolve, reject]);

  return asyncFunction.asyncFunction;
});

//

exports.default = useAsyncFunction;
